#ifndef __SLIDEPATH_H__
#define __SLIDEPATH_H__

#include "slideprimitive.h"

class CSLIDENode;

//////////////////////////////////////////////////////////////////////
// CSLIDEPath Class
//

class CSLIDEPath : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEPath();
  virtual ~CSLIDEPath();

  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CListInt *plistPathIDs);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);
  virtual CSLIDENode *FindNode(CSLIDENode *pRoot, CListIterInt *piterIDs, 
			       CListInt *plistCSLIDEInstance) = 0;

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
//////////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 5: Fix this!!!
// 
  virtual VOID UpdateState();
// 
// END  : ASSIGNMENT 5: Fix this!!!
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////
// Rendering
//
public:
//  virtual VOID Render(const Matrix &m);

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline const Matrix &GetGroot_obj() const;
  inline const Matrix &GetGobj_root() const;

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt *m_plistPathIDs; // A list of ID's which lead to the important Node
  
  CSLIDENode *m_pRoot;           // A root node to begin our traversal from
  CListInt m_listCSLIDEInstance; // List of Instances which lead us to the Node
  CSLIDENode *m_pNode;           // A pointer to the node for quick access

  Matrix m_mGroot_obj; // The smashed modelling transform of the path
  Matrix m_mGobj_root; // The smashed inverse modelling transform of the path
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline const Matrix &CSLIDEPath::GetGroot_obj() const
{
  return m_mGroot_obj;
}

inline const Matrix &CSLIDEPath::GetGobj_root() const
{
  return m_mGobj_root;
}

#endif // __SLIDEPATH_H__


